<template>
  <div class="row justify-content-center">
    <div class="col-md-12">
      <h1>User list</h1>
      <a-input-search
        placeholder="search name"
        enter-button
        style="width: 200px"
        @search="onSearch"
      />
      <router-link to="/create" tag="button" class="btn btn-primary float-right"
        >Add User</router-link
      >
      <br />
      <br />
      <br />
      <table class="table table-bordered">
        <thead>
          <tr>
            <th scope="col">No</th>
            <th scope="col">Name</th>
            <th scope="col">Email</th>
            <th scope="col">Phone</th>
            <th scope="col">Birth date</th>
            <th scope="col">Sex</th>
            <th scope="col">Address</th>
            <th scope="col">Company</th>
            <th scope="col" class="text-nowrap"></th>
          </tr>
        </thead>
        <tbody v-if="users.length > 0">
          <tr v-for="(user, index) in users" :key="index">
            <th scope="row">{{ index + 1 }}</th>
            <td>{{ user.name }}</td>
            <td>{{ user.email }}</td>
            <td>{{ user.phone }}</td>
            <td>{{ user.birthdate | moment("DD/MM/YYYY") }}</td>
            <td>{{ user.sex }}</td>
            <td>{{ user.address }}</td>
            <td>{{ user.company }}</td>
            <td class="text-nowrap">
              <div class="col">
                <router-link
                  :to="{ name: 'view', params: { id: user.id } }"
                  class="btn"
                  ><a-icon type="search"
                /></router-link>
                <router-link
                  :to="{ name: 'edit', params: { id: user.id } }"
                  class="btn"
                  ><a-icon type="edit"
                /></router-link>
                <button @click.prevent="deleteUser(user.id)" class="btn">
                  <a-icon type="delete" />
                </button>
              </div>
            </td>
          </tr>
        </tbody>
        <tbody v-if="users.length === 0">
          <tr>
            <td colspan="9">
              <a-empty />
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import AppConfig from "../../utils/config";

export default {
  data() {
    return {
      users: [],
      filter: {},
    };
  },

  mounted() {
    let api = AppConfig.config().api_url;
    console.log("api", api);
    let apiURL = api + "/api/user/search";
    axios
      .get(apiURL)
      .then((res) => {
        this.users = res.data.resultData;
      })
      .catch((error) => {
        console.log(error);
      });
  },
  methods: {
    onSearch(value) {
      console.log(value);
      this.filter.name = value;
      console.log(this.filter);
      let api = AppConfig.config().api_url;
      console.log("api", api);
      let apiURL = api + "/api/user/search";
      axios
        .get(apiURL,{
        params: this.filter
      })
        .then((res) => {
          this.users = res.data.resultData;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    deleteUser(id) {
      let api = AppConfig.config().api_url;
      let apiURL = api + `/api/user/delete/${id}`;
      let indexOfArray = this.users.findIndex((i) => i.id === id);

      if (window.confirm("Do you want to delete?")) {
        axios
          .delete(apiURL)
          .then(() => {
            this.users.splice(indexOfArray, 1);
          })
          .catch((error) => {
            console.log(error);
          });
      }
    },
  },
};
</script>

<style></style>
